/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      Project independent

  Description:  Project independent, global macro definitions

  -------------------------------------------------------------------------

  Revision History:

  2003/03/01 -rs:   Start of implementation

****************************************************************************/

#ifndef _MACROS_H_
#define _MACROS_H_



//---------------------------------------------------------------------------
// Dieses Makro berechnet die Gre einer Tabelle/Feldes. Es ist die Adresse 
// auf den Anfang der Tabelle zu bergeben. Bei mehrdimensionalen Feldern
// ist die Adresse auf den Anfang eines Vektors zu bergeben. 
#define tabentries(a)   (sizeof(a)/sizeof(*(a)))



//---------------------------------------------------------------------------
// Dieses Makro bestimmt den Offset eines Memeberelements innerhalb einer
// Struktur. Es sind der Typname der Struktur und des Memeberelements zu
// bergeben. Beispiel:
//
// typedef struct
// {
//     BYTE  m_bVar1;
//     WORD  m_wVar2;
//
// } tMyStruct;
//
// nOffsOfVar2 = memberoffs(tMyStruct, m_wVar2);
#define memberoffs(s,m)   (unsigned int)&(((s *)0)->m)



//---------------------------------------------------------------------------
// Dieses Makro bestimmt die Gre eines Memeberelements innerhalb einer
// Struktur. Es sind der Typname der Struktur und des Memeberelements zu
// bergeben. Beispiel:
//
// typedef struct
// {
//     BYTE  m_bVar1;
//     WORD  m_wVar2;
//
// } tMyStruct;
//
// nSizeOfVar2 = membersize(tMyStruct, m_wVar2);
#define membersize(s, m)   sizeof(((s *)0)->m)



#endif  // #ifndef _MACROS_H_

