/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      COMBImodul-C14

  Description:  source file for User Leds

  -------------------------------------------------------------------------

                $RCSfile: C14ULed.c,v $
                
                $Author: A.Suess $
                
                $Revision: 1.1 $  $Date: 2005/01/10 11:30:20 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2004/10/28 -as:   start of the implementation, version 1.00

****************************************************************************/

#include <intrins.h>
#include "generic/global.h"
#include "generic/gmacros.h"


/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*          G L O B A L   D E F I N I T I O N S                            */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

//---------------------------------------------------------------------------
// const defines
//---------------------------------------------------------------------------

#define MASK_USER_LED1  0x04
#define MASK_USER_LED2  0x08

#define ADR_MCR  ((BYTE xhuge*)(0x380000 + 0x04))

//---------------------------------------------------------------------------
// local types
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// modul globale vars
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// local function prototypes
//---------------------------------------------------------------------------


/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*          C L A S S  <User LED driver>                                   */
/*                                                                         */
/*                                                                         */
/***************************************************************************/
//
// Description:
//
//
/***************************************************************************/


//=========================================================================//
//                                                                         //
//          P R I V A T E   D E F I N I T I O N S                          //
//                                                                         //
//=========================================================================//

//---------------------------------------------------------------------------
// const defines
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// local types
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// local vars
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// local function prototypes
//---------------------------------------------------------------------------


//=========================================================================//
//                                                                         //
//          P U B L I C   F U N C T I O N S                                //
//                                                                         //
//=========================================================================//

//---------------------------------------------------------------------------
//
// Function:     C14SetUserLed
//
// Description:  This function sets the user leds connected to XUART.
//               Notice: If Sio driver is used for xuart, the user leds
//               switchs off if sio driver has been initialized or closed.
//
// Parameters:   bLed_p:     0 --> user led 1
//                           1 --> user led 2
//               bitState_p: 0 --> led off
//                           1 --> led on
//
// 
// Returns:      none
//
//
// State:        tested (28.10.2004 A.S.)
//
//---------------------------------------------------------------------------

void PUBLIC C14SetUserLed (BYTE bLed_p, bit bitState_p)
{
    switch (bLed_p)
    {
        //------------------------------------------
        case 0: if (bitState_p)
                    *ADR_MCR |= MASK_USER_LED1;
                else
                    *ADR_MCR &= ~MASK_USER_LED1;
        break;

        //------------------------------------------
        case 1: if (bitState_p)
                    *ADR_MCR |= MASK_USER_LED2;
                else
                    *ADR_MCR &= ~MASK_USER_LED2;
        break;
    }
}



